> ## Documentation Index
> Fetch the complete documentation index at: https://docs.seam.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Push Customer Data

> Pushes customer data including resources like spaces, properties, rooms, users, etc.



## OpenAPI

````yaml /openapi.json post /customers/push_data
openapi: 3.0.0
info:
  title: Seam Connect
  version: 1.0.0
servers:
  - url: https://connect.getseam.com
security: []
tags:
  - description: access_codes
    name: /access_codes
  - description: acs
    name: /acs
  - description: action_attempts
    name: /action_attempts
  - description: client_sessions
    name: /client_sessions
  - description: connected_accounts
    name: /connected_accounts
  - description: connect_webviews
    name: /connect_webviews
  - description: devices
    name: /devices
  - description: events
    name: /events
  - description: health
    name: /health
  - description: locks
    name: /locks
  - description: networks
    name: /networks
  - description: noise_sensors
    name: /noise_sensors
  - description: phones
    name: /phones
  - description: thermostats
    name: /thermostats
  - description: user_identities
    name: /user_identities
  - description: webhooks
    name: /webhooks
  - description: workspaces
    name: /workspaces
paths:
  /customers/push_data:
    post:
      tags: []
      summary: Push Customer Data
      description: >-
        Pushes customer data including resources like spaces, properties, rooms,
        users, etc.
      operationId: customersPushDataPost
      requestBody:
        content:
          application/json:
            schema:
              properties:
                access_grants:
                  description: List of access grants.
                  items:
                    properties:
                      access_grant_key:
                        description: Your unique identifier for the access grant.
                        minLength: 1
                        type: string
                      building_keys:
                        description: Building keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      common_area_keys:
                        description: Common area keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      ends_at:
                        description: Ending date and time for the access grant.
                        format: date-time
                        type: string
                      facility_keys:
                        description: Facility keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      guest_key:
                        description: Guest key associated with the access grant.
                        type: string
                      listing_keys:
                        description: Listing keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      name:
                        description: Your name for this access grant resource.
                        type: string
                      preferred_code:
                        description: >-
                          Preferred PIN code to use when creating access for
                          this reservation.
                        type: string
                      property_keys:
                        description: Property keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      resident_key:
                        description: Resident key associated with the access grant.
                        type: string
                      room_keys:
                        description: Room keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      space_keys:
                        description: Space keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      starts_at:
                        description: Starting date and time for the access grant.
                        format: date-time
                        type: string
                      tenant_key:
                        description: Tenant key associated with the access grant.
                        type: string
                      unit_keys:
                        description: Unit keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      user_identity_key:
                        description: User identity key associated with the access grant.
                        type: string
                      user_key:
                        description: User key associated with the access grant.
                        type: string
                    required:
                      - access_grant_key
                    type: object
                  type: array
                bookings:
                  description: List of bookings.
                  items:
                    properties:
                      booking_key:
                        description: Your unique identifier for the booking.
                        minLength: 1
                        type: string
                      building_keys:
                        description: Building keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      common_area_keys:
                        description: Common area keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      ends_at:
                        description: Ending date and time for the access grant.
                        format: date-time
                        type: string
                      facility_keys:
                        description: Facility keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      guest_key:
                        description: Guest key associated with the access grant.
                        type: string
                      listing_keys:
                        description: Listing keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      name:
                        description: Your name for this access grant resource.
                        type: string
                      preferred_code:
                        description: >-
                          Preferred PIN code to use when creating access for
                          this reservation.
                        type: string
                      property_keys:
                        description: Property keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      resident_key:
                        description: Resident key associated with the access grant.
                        type: string
                      room_keys:
                        description: Room keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      space_keys:
                        description: Space keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      starts_at:
                        description: Starting date and time for the access grant.
                        format: date-time
                        type: string
                      tenant_key:
                        description: Tenant key associated with the access grant.
                        type: string
                      unit_keys:
                        description: Unit keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      user_identity_key:
                        description: User identity key associated with the access grant.
                        type: string
                      user_key:
                        description: User key associated with the access grant.
                        type: string
                    required:
                      - booking_key
                    type: object
                  type: array
                buildings:
                  description: List of buildings.
                  items:
                    properties:
                      building_key:
                        description: Your unique identifier for the building.
                        minLength: 1
                        type: string
                      name:
                        description: Your display name for this location resource.
                        type: string
                    required:
                      - name
                      - building_key
                    type: object
                  type: array
                common_areas:
                  description: List of shared common areas.
                  items:
                    properties:
                      common_area_key:
                        description: Your unique identifier for the common area.
                        minLength: 1
                        type: string
                      name:
                        description: Your display name for this location resource.
                        type: string
                      parent_site_key:
                        description: Your unique identifier for the site.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - common_area_key
                    type: object
                  type: array
                customer_key:
                  description: Your unique identifier for the customer.
                  minLength: 1
                  type: string
                facilities:
                  description: List of gym or fitness facilities.
                  items:
                    properties:
                      facility_key:
                        description: Your unique identifier for the facility.
                        minLength: 1
                        type: string
                      name:
                        description: Your display name for this location resource.
                        type: string
                    required:
                      - name
                      - facility_key
                    type: object
                  type: array
                guests:
                  description: List of guests.
                  items:
                    properties:
                      email_address:
                        description: Email address associated with the user identity.
                        type: string
                      guest_key:
                        description: Your unique identifier for the guest.
                        minLength: 1
                        type: string
                      name:
                        description: Your display name for this user identity resource.
                        type: string
                      phone_number:
                        description: Phone number associated with the user identity.
                        type: string
                    required:
                      - name
                      - guest_key
                    type: object
                  type: array
                listings:
                  description: List of property listings.
                  items:
                    properties:
                      listing_key:
                        description: Your unique identifier for the listing.
                        minLength: 1
                        type: string
                      name:
                        description: Your display name for this location resource.
                        type: string
                    required:
                      - name
                      - listing_key
                    type: object
                  type: array
                properties:
                  description: List of short-term rental properties.
                  items:
                    properties:
                      name:
                        description: Your display name for this location resource.
                        type: string
                      property_key:
                        description: Your unique identifier for the property.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - property_key
                    type: object
                  type: array
                property_listings:
                  description: List of property listings.
                  items:
                    properties:
                      custom_metadata:
                        additionalProperties:
                          nullable: true
                          oneOf:
                            - maxLength: 500
                              type: string
                            - type: boolean
                        description: >-
                          Set key:value pairs. Accepts string or Boolean values.
                          Adding custom metadata to a property listing enables
                          you to store custom information, like customer details
                          or internal IDs from your application.
                        type: object
                      name:
                        description: Your display name for this location resource.
                        type: string
                      property_listing_key:
                        description: Your unique identifier for the property listing.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - property_listing_key
                    type: object
                  type: array
                reservations:
                  description: List of reservations.
                  items:
                    properties:
                      building_keys:
                        description: Building keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      common_area_keys:
                        description: Common area keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      custom_metadata:
                        additionalProperties:
                          nullable: true
                          oneOf:
                            - maxLength: 500
                              type: string
                            - type: boolean
                        description: >-
                          Set key:value pairs for filtering reservations by
                          custom criteria.
                        type: object
                      ends_at:
                        description: Ending date and time for the access grant.
                        format: date-time
                        type: string
                      facility_keys:
                        description: Facility keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      guest_key:
                        description: Guest key associated with the access grant.
                        type: string
                      listing_keys:
                        description: Listing keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      name:
                        description: Your name for this access grant resource.
                        type: string
                      preferred_code:
                        description: >-
                          Preferred PIN code to use when creating access for
                          this reservation.
                        type: string
                      property_keys:
                        description: Property keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      reservation_key:
                        description: Your unique identifier for the reservation.
                        minLength: 1
                        type: string
                      resident_key:
                        description: Resident key associated with the access grant.
                        type: string
                      room_keys:
                        description: Room keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      space_keys:
                        description: Space keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      starts_at:
                        description: Starting date and time for the access grant.
                        format: date-time
                        type: string
                      tenant_key:
                        description: Tenant key associated with the access grant.
                        type: string
                      unit_keys:
                        description: Unit keys associated with the access grant.
                        items:
                          type: string
                        type: array
                      user_identity_key:
                        description: User identity key associated with the access grant.
                        type: string
                      user_key:
                        description: User key associated with the access grant.
                        type: string
                    required:
                      - reservation_key
                    type: object
                  type: array
                residents:
                  description: List of residents.
                  items:
                    properties:
                      email_address:
                        description: Email address associated with the user identity.
                        type: string
                      name:
                        description: Your display name for this user identity resource.
                        type: string
                      phone_number:
                        description: Phone number associated with the user identity.
                        type: string
                      resident_key:
                        description: Your unique identifier for the resident.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - resident_key
                    type: object
                  type: array
                rooms:
                  description: List of hotel or hospitality rooms.
                  items:
                    properties:
                      name:
                        description: Your display name for this location resource.
                        type: string
                      parent_site_key:
                        description: Your unique identifier for the site.
                        minLength: 1
                        type: string
                      room_key:
                        description: Your unique identifier for the room.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - room_key
                    type: object
                  type: array
                sites:
                  description: List of general sites or areas.
                  items:
                    properties:
                      name:
                        description: Your display name for this location resource.
                        type: string
                      site_key:
                        description: Your unique identifier for the site.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - site_key
                    type: object
                  type: array
                spaces:
                  description: List of general spaces or areas.
                  items:
                    properties:
                      customer_data:
                        description: >-
                          Reservation/stay-related defaults for the space (time
                          zone, default check-in/out times, address).
                        properties:
                          address:
                            description: Postal address for the space.
                            nullable: true
                            type: string
                          default_checkin_time:
                            description: >-
                              Default check-in time for reservations at the
                              space, as HH:mm or HH:mm:ss.
                            nullable: true
                            pattern: ^([01]\d|2[0-3]):[0-5]\d(:[0-5]\d)?$
                            type: string
                          default_checkout_time:
                            description: >-
                              Default check-out time for reservations at the
                              space, as HH:mm or HH:mm:ss.
                            nullable: true
                            pattern: ^([01]\d|2[0-3]):[0-5]\d(:[0-5]\d)?$
                            type: string
                          time_zone:
                            description: >-
                              IANA time zone for the space, e.g.
                              America/Los_Angeles.
                            nullable: true
                            type: string
                        type: object
                      duration_minutes:
                        description: >-
                          Default duration of this space in minutes, when the
                          space represents a fixed-length bookable slot (e.g. an
                          appointment type). Used to interpret reservations
                          booked against this space.
                        exclusiveMinimum: true
                        minimum: 0
                        type: integer
                      geolocation:
                        description: >-
                          Geographic coordinates (latitude and longitude) of the
                          space.
                        properties:
                          latitude:
                            description: Latitude of the space, in decimal degrees.
                            format: float
                            type: number
                          longitude:
                            description: Longitude of the space, in decimal degrees.
                            format: float
                            type: number
                        required:
                          - latitude
                          - longitude
                        type: object
                      name:
                        description: Your display name for this location resource.
                        type: string
                      parent_site_key:
                        description: Your unique identifier for the site.
                        minLength: 1
                        type: string
                      space_key:
                        description: Your unique identifier for the space.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - space_key
                    type: object
                  type: array
                staff_members:
                  description: List of staff members.
                  items:
                    description: Represents a staff member for a specific customer.
                    properties:
                      building_keys:
                        description: >-
                          List of unique identifiers for the buildings the staff
                          member is associated with.
                        items:
                          type: string
                        type: array
                      common_area_keys:
                        description: >-
                          List of unique identifiers for the common areas the
                          staff member is associated with.
                        items:
                          type: string
                        type: array
                      email_address:
                        description: Email address associated with the user identity.
                        type: string
                      facility_keys:
                        description: >-
                          List of unique identifiers for the facilities the
                          staff member is associated with.
                        items:
                          type: string
                        type: array
                      listing_keys:
                        description: >-
                          List of unique identifiers for the listings the staff
                          member is associated with.
                        items:
                          type: string
                        type: array
                      name:
                        description: Your display name for this user identity resource.
                        type: string
                      phone_number:
                        description: Phone number associated with the user identity.
                        type: string
                      property_keys:
                        description: >-
                          List of unique identifiers for the properties the
                          staff member is associated with.
                        items:
                          type: string
                        type: array
                      property_listing_keys:
                        description: >-
                          List of unique identifiers for the property listings
                          the staff member is associated with.
                        items:
                          type: string
                        type: array
                      room_keys:
                        description: >-
                          List of unique identifiers for the rooms the staff
                          member is associated with.
                        items:
                          type: string
                        type: array
                      site_keys:
                        description: >-
                          List of unique identifiers for the sites the staff
                          member is associated with.
                        items:
                          type: string
                        type: array
                      space_keys:
                        description: >-
                          List of unique identifiers for the spaces the staff
                          member is associated with.
                        items:
                          type: string
                        type: array
                      staff_member_key:
                        description: Your unique identifier for the staff.
                        type: string
                      unit_keys:
                        description: >-
                          List of unique identifiers for the units the staff
                          member is associated with.
                        items:
                          type: string
                        type: array
                    required:
                      - name
                      - staff_member_key
                    type: object
                    x-route-path: /seam/customer/v1/staff_members
                    x-undocumented: Internal resource for customer portals.
                  type: array
                tenants:
                  description: List of tenants.
                  items:
                    properties:
                      email_address:
                        description: Email address associated with the user identity.
                        type: string
                      name:
                        description: Your display name for this user identity resource.
                        type: string
                      phone_number:
                        description: Phone number associated with the user identity.
                        type: string
                      tenant_key:
                        description: Your unique identifier for the tenant.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - tenant_key
                    type: object
                  type: array
                units:
                  description: List of multi-family residential units.
                  items:
                    properties:
                      name:
                        description: Your display name for this location resource.
                        type: string
                      parent_site_key:
                        description: Your unique identifier for the site.
                        minLength: 1
                        type: string
                      unit_key:
                        description: Your unique identifier for the unit.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - unit_key
                    type: object
                  type: array
                user_identities:
                  description: List of user identities.
                  items:
                    properties:
                      email_address:
                        description: Email address associated with the user identity.
                        type: string
                      name:
                        description: Your display name for this user identity resource.
                        type: string
                      phone_number:
                        description: Phone number associated with the user identity.
                        type: string
                      user_identity_key:
                        description: Your unique identifier for the user identity.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - user_identity_key
                    type: object
                  type: array
                users:
                  description: List of users.
                  items:
                    properties:
                      email_address:
                        description: Email address associated with the user identity.
                        type: string
                      name:
                        description: Your display name for this user identity resource.
                        type: string
                      phone_number:
                        description: Phone number associated with the user identity.
                        type: string
                      user_key:
                        description: Your unique identifier for the user.
                        minLength: 1
                        type: string
                    required:
                      - name
                      - user_key
                    type: object
                  type: array
              required:
                - customer_key
              type: object
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  ok:
                    type: boolean
                required:
                  - ok
                type: object
          description: OK
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
      security:
        - pat_with_workspace: []
        - console_session_with_workspace: []
        - api_key: []
components:
  securitySchemes:
    pat_with_workspace:
      bearerFormat: API Token
      scheme: bearer
      type: http
    console_session_with_workspace:
      bearerFormat: Console Session Token
      scheme: bearer
      type: http
    api_key:
      bearerFormat: API Key
      scheme: bearer
      type: http

````